function s4() {
    return Math.floor((1 + Math.random()) * 0x10000)
               .toString(16)
               .substring(1);
  }

function generateID() {
	// returns a UUID as new ID for diferent values. will be allways a string
	return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
		           s4() + '-' + s4() + s4() + s4();
}

var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var BusMember_dSM11 = 16;
var BusMember_dSM12 = 17;
var BusMember_vDSM  = 32;
var BusMember_vDC   = 33;

var LOGFILE_NAME = "heating-controller.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function storeParameter(path,value)
{
	Property.setProperty(path, value);
	Property.setFlag(path, 'ARCHIVE', true);
}

var OperationModes = {
		Off : 0,
		Comfort : 1,
		Eco : 2,
		NotUsed : 3,
		Night : 4,
		Holiday : 5,
	    Cooling : 6,
	    CoolingOff : 7,
	    Manual : 8,
		nothing : -1
	};

var DefinitionIDs = {
	ModeOff : 0,
	ModeZoneFollower : -2,
	ModeFixedValue : -3,
	AutoNothingSelected : -4,
	AutoSelectionFailed : -5,
	AutoSelectionNotPossible : -6,
    AutoSelectionNoController : -7
};

var ControlModeIDs = {
	ControlModeIDOff : 0,
	ControlModeIDPID : 1,
	ControlModeIDZoneFollower : 2,
	ControlModeIDFixed : 3,
	ControlModeIDManual : 4
};

var defaultFixedValues={
		'Off':0,
		'Comfort' : 100,
		'Economy' : 50,
		'NotUsed' : 0,
		'Night' : 0,
		'Holiday' : 0,
		'Cooling' : -100,
		'CoolingOff' :0
};

var defaultTemperatureValues={
		'Off':8,
		'Comfort' : 22,
		'Economy' : 20,
		'NotUsed' : 18,
		'Night'   : 17,
		'Holiday' : 16,
		'Cooling' : 23,
		'CoolingOff' : 50
};

var temperatureLimits ={
		'Off'     : -41,
		'Comfort' : -41,
		'Economy' : -41,
		'NotUsed' : -41,
		'Night'   : -41,
		'Holiday' : -41,
		'Cooling' : -41,
		'CoolingOff' : -41
};

var stateValues = {
	active : 1,
	inactive : 2
};

var StatusApartmentController = {
	controller_off : 0,
	heating : 1,
	cooling : 2
};


var StatusWaterHeatingSystem = {
	noWater   : 0,
	hotWater  : 1,
	coldWater : 2

};

var HeatingCapabilities = {
	heatingOnly : 1,
	heatingCooling : 2
};

var ApartmentClimateControlOn = 29;
var ApartmentClimateControlOff = 30;

var CoolingParametersPID = {
	ControlMode : ControlModeIDs.ControlModeIDPID,
	EmergencyValue : 0,
	CtrlKp : 0.025,
	CtrlTs : 1,
	CtrlTi : 1,
	CtrlKd : 0.0,
	CtrlImin : 0,
	CtrlImax : 0,
	CtrlYmin : -100,
	CtrlYmax : 0,
	CtrlAntiWindUp : false,
	CtrlKeepFloorWarm : false
};

function offlineValues () {
	Property.setProperty('controllerDefinitions/1/id',1);
	Property.setProperty('controllerDefinitions/1/type',1);
	Property.setProperty('controllerDefinitions/1/controllerMode',1);
	Property.setProperty('controllerDefinitions/1/name','default radiator heating');
	Property.setProperty('controllerDefinitions/1/kp',"5.0");
	Property.setProperty('controllerDefinitions/1/ts',1);
	Property.setProperty('controllerDefinitions/1/kd',0);
	Property.setProperty('controllerDefinitions/1/ti',150);
	Property.setProperty('controllerDefinitions/1/imin',"-13.33");
	Property.setProperty('controllerDefinitions/1/imax',"13.33");
	Property.setProperty('controllerDefinitions/1/ymin',0);
	Property.setProperty('controllerDefinitions/1/ymax',100);
	Property.setProperty('controllerDefinitions/1/antiwindup',1);
	Property.setProperty('controllerDefinitions/1/keepfloorwarm',0);
	Property.setProperty('controllerDefinitions/1/emergency', 75);
	Property.setProperty('controllerDefinitions/2/id',2);
	Property.setProperty('controllerDefinitions/2/type',2);
	Property.setProperty('controllerDefinitions/2/controllerMode',1);
	Property.setProperty('controllerDefinitions/2/name','default floor heating');
	Property.setProperty('controllerDefinitions/2/kp',"5.0");
	Property.setProperty('controllerDefinitions/2/ts',1);
	Property.setProperty('controllerDefinitions/2/kd',0);
	Property.setProperty('controllerDefinitions/2/ti',240);
	Property.setProperty('controllerDefinitions/2/imin',"-13.33");
	Property.setProperty('controllerDefinitions/2/imax',"13.33");
	Property.setProperty('controllerDefinitions/2/ymin',0);
	Property.setProperty('controllerDefinitions/2/ymax',100);
	Property.setProperty('controllerDefinitions/2/antiwindup',1);
	Property.setProperty('controllerDefinitions/2/keepfloorwarm',0);
	Property.setProperty('controllerDefinitions/2/emergency', 75);
}

function reactOnAbsent () {
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/type','zone-scene');
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/zone',0);
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/group',0);
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/scene',72);
	Property.setProperty('/scripts/heating-controller/systemTriggers/absent/triggers/1/dsid',-1);
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/type','zone-scene');
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/zone',0);
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/group',0);
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/scene',71);
	Property.setProperty('/scripts/heating-controller/systemTriggers/present/triggers/1/dsid',-1);
	
	registerTrigger('/scripts/heating-controller/systemTriggers/absent','heating-controller.operation-mode',{'actions':'reactOnAbsent'});
	registerTrigger('/scripts/heating-controller/systemTriggers/present','heating-controller.operation-mode',{'actions':'reactOnPresent'});	
}

function ensureQueueTrigger() {
	registerState('queue-active',false);
	Property.setProperty('/scripts/heating-controller/systemTriggers/queue/triggers/1/type','addon-state-change');
	Property.setProperty('/scripts/heating-controller/systemTriggers/queue/triggers/1/name','queue-active');
	Property.setProperty('/scripts/heating-controller/systemTriggers/queue/triggers/1/state',"inactive");
	Property.setProperty('/scripts/heating-controller/systemTriggers/queue/triggers/1/addon-id','heating-controller');
	registerTrigger('/scripts/heating-controller/systemTriggers/queue','heating-controller.operation-mode',{'actions':'queue-ready'});
}

function ensureApartmentController() {
	registerState('apartment_controller', true);
	try {
		var states = ['off', 'heating', 'cooling'];
		getState('apartment_controller').setValueRange(states);
	} catch (e) {
		lWarn.logln('apartment controller function setValueRange not supported: ' + e + ' check dss version!');
	}
	getState('apartment_controller').setValue(StatusApartmentController.controller_off);
}

function insertHolidayTrigger() {
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/1/type','state-change');
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/1/name','holiday');
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/1/state',"on");
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/2/type','state-change');
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/2/name','holiday');
	Property.setProperty('/scripts/heating-controller/systemTriggers/holiday/triggers/2/state',"off");
	registerTrigger('/scripts/heating-controller/systemTriggers/holiday','heating-controller.preheating-time',{'actions':'checkHoliday'});
}

function getControllerDsuidForZone(zoneID) {
	var zZone = getZoneByID(parseInt('' + zoneID, 10));
	var config = zZone.getTemperatureControlConfiguration();
	lInfo.logln('get controller dsuid for zone id: ' + zoneID + ' controller dsuid: ' +config.ControlDSUID);
	return config.ControlDSUID;
}

function updateDevices() {
	lInfo.logln('updateDevices');
	var enabledState = getState('apartment_controller').getValue();
	if (enabledState == StatusApartmentController.controller_off) {
		try {
			var zones = getZones();
			var index, len;
			for (index = 0, len = zones.length; index < len; ++index) {
				var zone = zones[index];
				// reconfigure operation mode
				new Event('heating-controller.operation-mode', {
					'zoneID':zone.id,
					'actions':'evaluateRealActiveMode',
					'forceUpdate':'true'
				}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on updateDevices' + e);
		}
	}
}

function sendApartmentClimateControl() {
	var enabledState = getState('apartment_controller').getValue();
	if (enabledState != StatusApartmentController.controller_off) {
		lInfo.logln('sendApartmentClimateControl ON');
		getZoneByID(0).callScene(48, ApartmentClimateControlOn);
	} else {
		lInfo.logln('sendApartmentClimateControl OFF');
		getZoneByID(0).callScene(48, ApartmentClimateControlOff);
	}
}

function updateTemperature(zoneId) {
    lInfo.logln('updateTemperature for zone: ' + zoneId);

    var nodeType = 0;
    try {
        nodeType = Property.getNode('controllerConfig/' + zoneId +'/definitionID').getValue();
    } catch (e) {
        lWarn.logln('Error getting mode for updateTemperature. ' + e);
        return;
    }

    var node = Property.getNode('modes/' + zoneId);
    if (nodeType > DefinitionIDs.ModeOff) {
        node = Property.getNode('modes/' + zoneId + '/Temperature');
    } else {
        node = Property.getNode('modes/' + zoneId + '/Percent');
    }

    if (!node) {
        lWarn.logln('node "modes/' + zoneId + '" does not exist.');
        return;
    }
    try {
        var temperatureValues = {};
        var tempOff = node.getChild('OffTemperatur').getValue();
        if (tempOff != null) { temperatureValues.Off = tempOff;}

        var tempEco = node.getChild('EcoTemperatur').getValue();
        if (tempEco != null) { temperatureValues.Economy = tempEco;}

        var tempNight = node.getChild('NightTemperatur').getValue();
        if (tempNight != null) { temperatureValues.Night = tempNight;}

        var tempHoliday = node.getChild('HolidayTemperatur').getValue();
        if (tempHoliday != null) { temperatureValues.Holiday = tempHoliday;}

        var tempComfort = node.getChild('ComfortTemperatur').getValue();
        if (tempComfort != null) { temperatureValues.Comfort = tempComfort;}

        var tempNotUsed = node.getChild('notUsedTemperatur').getValue();
        if (tempNotUsed != null) { temperatureValues.NotUsed = tempNotUsed;}

        var tempCooling = node.getChild('coolingTemperatur').getValue();
        if (tempCooling != null) { temperatureValues.Cooling = tempCooling;}

        var tempCoolingOff = node.getChild('coolingOffTemperatur').getValue();
        if (tempCoolingOff != null) { temperatureValues.CoolingOff = tempCoolingOff;}

        var zZone = getZoneByID(parseInt("" + zoneId, 10));
        lInfo.logln('updateTemperature values: ' + JSON.stringify(temperatureValues));
        zZone.setTemperatureControlValues(temperatureValues);
    } catch (e) {
        lWarn.logln('Error on updateTemperature. ' + e);
    }
}

function reconfigureCooling(zone, force ,mode) {
	lInfo.logln('reconfigureCooling for zone: ' + zone.id);
	var controlConfig = zone.getTemperatureControlConfiguration();
	if (controlConfig.IsConfigured) {
		var dSM = getControllerDsuidForZone(zone.id);
		if (dSM == null) {
			lWarn.logln('reconfigureCooling no climate controller found for zone ' + zone.id);
		} else {
			if ((force && (mode == ControlModeIDs.ControlModeIDPID)) ||
			    (controlConfig.ControlMode == ControlModeIDs.ControlModeIDPID)) {

				// check if controller configuration has changed.
				var configIdentical = false;
				try {
					configIdentical = ((controlConfig.CtrlKp.toFixed(1) == CoolingParametersPID.CtrlKp.toFixed(1)) &&
						(controlConfig.CtrlTs.toFixed(1) == CoolingParametersPID.CtrlTs.toFixed(1)) &&
						(controlConfig.CtrlTi.toFixed(1) == CoolingParametersPID.CtrlTi.toFixed(1)) &&
						(controlConfig.CtrlKd.toFixed(1) == CoolingParametersPID.CtrlKd.toFixed(1)) &&
						(controlConfig.CtrlImin.toFixed(1) == CoolingParametersPID.CtrlImin.toFixed(1)) &&
						(controlConfig.CtrlImax.toFixed(1) == CoolingParametersPID.CtrlImax.toFixed(1)) &&
						(controlConfig.CtrlYmin.toFixed(1) == CoolingParametersPID.CtrlYmin.toFixed(1)) &&
						(controlConfig.CtrlYmax.toFixed(1) == CoolingParametersPID.CtrlYmax.toFixed(1)) &&
						(controlConfig.CtrlAntiWindUp == CoolingParametersPID.CtrlAntiWindUp) &&
						(controlConfig.CtrlKeepFloorWarm == CoolingParametersPID.CtrlKeepFloorWarm));
				} catch (e) {
					lWarn.logln('reconfigureCooling configurations could not be compared. assuming not identical');
					configIdentical = false;
				}
				if (!configIdentical) {
					lInfo.logln('reconfigureCooling setting pid values to controller: ' + JSON.stringify(CoolingParametersPID));
					try {
						zone.setTemperatureControlConfiguration(dSM, CoolingParametersPID);
						lInfo.logln('reconfigureCooling done for Control Mode PID');
					} catch (e) {
						lWarn.logln(e);
					}
				} else {
					lInfo.logln('reconfigureCooling pid not needed for Control Mode PID. Configuration already up to date.');
				}
				updateTemperature(zone.id);
			}

			// zone follower
			if ((force && (mode == ControlModeIDs.ControlModeIDZoneFollower)) ||
			    (controlConfig.ControlMode == ControlModeIDs.ControlModeIDZoneFollower)) {

				// check if zone has a heating controller assigned.
				var oParameter = {
					ControlMode : ControlModeIDs.ControlModeIDZoneFollower,
					EmergencyValue : 75
				}

				oParameter.ReferenceZone  = parseFloat("" + Property.getProperty('controllerConfig/' + zone.id + '/followedZone'));
				oParameter.CtrlOffset     = 0;
				oParameter.EmergencyValue = parseFloat("" + Property.getProperty('controllerConfig/' + zone.id + '/emergenyValue'));

				// check if controller configuration has changed.
				var configIdentical = false;
				try {
					configIdentical =
						((controlConfig.ReferenceZone.toFixed(1) == oParameter.ReferenceZone.toFixed(1)) &&
						(controlConfig.CtrlOffset.toFixed(1) == oParameter.CtrlOffset.toFixed(1)) &&
						(controlConfig.EmergencyValue.toFixed(1) == oParameter.EmergencyValue.toFixed(1)));
				} catch (e) {
					lWarn.logln('reconfigureHeating zone follower configurations could not be compared. assuming not identical');
					configIdentical = false;
				}

				if (!configIdentical) {
					lInfo.logln('reconfigureCooling zone follower setting values for controller ' + JSON.stringify(oParameter));
					try {
						zone.setTemperatureControlConfiguration(dSM, oParameter);
						lInfo.logln('reconfigureCooling done for Control Mode zone follower');
					} catch (e) {
						lWarn.logln(e);
					}
				} else {
					lInfo.logln('reconfigureCooling not needed for Control Mode zone follower. Configuration already up to date.');
				}
			}

			// manual mode
			if ((force && (mode == ControlModeIDs.ControlModeIDManual)) ||
			    (controlConfig.ControlMode == ControlModeIDs.ControlModeIDManual)) {
				try {
					zone.setTemperatureControlConfiguration(dSM, CoolingParametersPID);
					lInfo.logln('reconfigureCooling done for Control Manual Mode: ' +
						JSON.stringify(CoolingParametersPID));
					Property.setProperty('controllerConfig/' + zone.id + '/fManualOverride', false);
					lInfo.logln('reconfigureCooling: switch off manual mode');
				} catch (e) {
					lWarn.logln(e);
				}
			}
		}
		// reconfigure operation mode
		new Event('heating-controller.operation-mode', {
			'zoneID':zone.id,
			'actions':'evaluateRealActiveMode',
			'forceUpdate':'true'
		}).raise();
	}
}

function reconfigureHeating(zone, force, mode) {
	lInfo.logln('reconfigureHeating for zone: ' + zone.id);
	var controlConfig = zone.getTemperatureControlConfiguration();
	if (controlConfig.IsConfigured) {
		var dSM = getControllerDsuidForZone(zone.id);
		if (dSM == null) {
			lWarn.logln('reconfigureHeating no climate controller found for zone ' + zone.id);
		} else {
			if ((force && (mode == ControlModeIDs.ControlModeIDPID)) ||
			    (controlConfig.ControlMode == ControlModeIDs.ControlModeIDPID)) {
				// check if zone has a heating controller assigned.
				var oParameter = {
					ControlMode : ControlModeIDs.ControlModeIDPID,
					EmergencyValue : 75
				};

				var definitionID = Property.getNode('controllerConfig/' + zone.id + '/definitionID').getValue();
				if (Property.getNode('controllerConfig/' + zone.id + '/emergenyValue')!=null) {
					oParameter.EmergencyValue=Property.getProperty('controllerConfig/' + zone.id + '/emergenyValue');
				}
				if (Property.getNode('controllerDefinitions/' + definitionID) == null) {
					lWarn.logln('illegal definitionID: ' + definitionID);
					return;
				}
				oParameter.CtrlKp = parseFloat("" + Property.getProperty('controllerDefinitions/' + definitionID + '/kp'));
				oParameter.CtrlTs =  parseFloat("" + Property.getProperty('controllerDefinitions/' + definitionID + '/ts'));
				oParameter.CtrlTi =  parseFloat("" + Property.getProperty('controllerDefinitions/' + definitionID + '/ti'));
				oParameter.CtrlKd =  parseFloat("" + Property.getProperty('controllerDefinitions/' + definitionID + '/kd'));
				oParameter.CtrlImin = parseFloat("" + Property.getProperty('controllerDefinitions/' + definitionID + '/imin'));
				oParameter.CtrlImax = parseFloat("" + Property.getProperty('controllerDefinitions/' + definitionID + '/imax'));
				oParameter.CtrlYmin = Property.getProperty('controllerDefinitions/' + definitionID + '/ymin');
				oParameter.CtrlYmax = Property.getProperty('controllerDefinitions/' + definitionID + '/ymax');
				oParameter.CtrlAntiWindUp = ((Property.getProperty('controllerDefinitions/' + definitionID + '/antiwindup')!=0)?true:false);
				oParameter.CtrlKeepFloorWarm = ((Property.getProperty('controllerDefinitions/' + definitionID + '/keepfloorwarm')!=0)?true:false);

				// check if controller configuration has changed.
				var configIdentical = false;
				try {
					configIdentical =
						((controlConfig.CtrlKp.toFixed(1) == oParameter.CtrlKp.toFixed(1)) &&
						(controlConfig.CtrlTs.toFixed(1) == oParameter.CtrlTs.toFixed(1)) &&
						(controlConfig.CtrlTi.toFixed(1) == oParameter.CtrlTi.toFixed(1)) &&
						(controlConfig.CtrlKd.toFixed(1) == oParameter.CtrlKd.toFixed(1)) &&
						(controlConfig.CtrlImin.toFixed(1) == oParameter.CtrlImin.toFixed(1)) &&
						(controlConfig.CtrlImax.toFixed(1) == oParameter.CtrlImax.toFixed(1)) &&
						(controlConfig.CtrlYmin.toFixed(1) == oParameter.CtrlYmin.toFixed(1)) &&
						(controlConfig.CtrlYmax.toFixed(1) == oParameter.CtrlYmax.toFixed(1)) &&
						(controlConfig.CtrlAntiWindUp == oParameter.CtrlAntiWindUp) &&
						(controlConfig.CtrlKeepFloorWarm == oParameter.CtrlKeepFloorWarm));
				} catch (e) {
					lWarn.logln('reconfigureHeating  pid configurations could not be compared. assuming not identical');
					configIdentical = false;
				}

				if (!configIdentical) {
					lInfo.logln('reconfigureHeating setting pid values to controller definition(' + definitionID + ') ' + JSON.stringify(oParameter));
					try {
						zone.setTemperatureControlConfiguration(dSM, oParameter);
						lInfo.logln('reconfigureHeating done for Control Mode PID');
					} catch (e) {
						lWarn.logln(e);
					}
				} else {
					lInfo.logln('reconfigureHeating not needed for Control Mode PID. Configuration already up to date.');
				}
				updateTemperature(zone.id);
			}

			// zone follower
			if ((force && (mode == ControlModeIDs.ControlModeIDZoneFollower)) ||
			    (controlConfig.ControlMode == ControlModeIDs.ControlModeIDZoneFollower)) {

				// check if zone has a heating controller assigned.
				var oParameter = {
					ControlMode : ControlModeIDs.ControlModeIDZoneFollower,
					EmergencyValue : 75
				}

				oParameter.ReferenceZone  = parseFloat("" + Property.getProperty('controllerConfig/' + zone.id + '/followedZone'));
				oParameter.CtrlOffset     = parseFloat("" + Property.getProperty('controllerConfig/' + zone.id + '/offset'));
				oParameter.EmergencyValue = parseFloat("" + Property.getProperty('controllerConfig/' + zone.id + '/emergenyValue'));

				// check if controller configuration has changed.
				var configIdentical = false;
				try {
					configIdentical =
						((controlConfig.ReferenceZone.toFixed(1) == oParameter.ReferenceZone.toFixed(1)) &&
						(controlConfig.CtrlOffset.toFixed(1) == oParameter.CtrlOffset.toFixed(1)) &&
						(controlConfig.EmergencyValue.toFixed(1) == oParameter.EmergencyValue.toFixed(1)));
				} catch (e) {
					lWarn.logln('reconfigureHeating zone follower configurations could not be compared. assuming not identical');
					configIdentical = false;
				}

				if (!configIdentical) {
					lInfo.logln('reconfigureHeating zone follower setting values for controller definition ' + JSON.stringify(oParameter));
					try {
						zone.setTemperatureControlConfiguration(dSM, oParameter);
						lInfo.logln('reconfigureHeating done for Control Mode zone follower');
					} catch (e) {
						lWarn.logln(e);
					}
				} else {
					lInfo.logln('reconfigureHeating not needed for Control Mode zone follower. Configuration already up to date.');
				}
			}
		}
		// reconfigure operation mode
		new Event('heating-controller.operation-mode', {
			'zoneID':zone.id,
			'actions':'evaluateRealActiveMode',
			'forceUpdate': 'true'
		}).raise();
	}
}

function synchronizeZoneParameters(apartmentControllerState, force) {
    lInfo.logln('synchronizePIDParameters');
    try {
        var zones = getZones();
        var index, len;
        for (index = 0, len = zones.length; index < len; ++index) {
            var zone = zones[index];
            if (apartmentControllerState == StatusApartmentController.cooling) {
                reconfigureCooling(zone, force, 0);
            }
            else if (apartmentControllerState == StatusApartmentController.heating) {
                reconfigureHeating(zone, force, 0);
            }
        }
    } catch (e) {
        lWarn.logln('Error on synchronizePIDParameters ' + e);
    }
}

function setZoneParameters(zone, force, mode)
{
	var apartmentControllerState = getState('apartment_controller').getValue();
	if (apartmentControllerState == StatusApartmentController.cooling) {
		reconfigureCooling(zone, force, mode);
	} else {
		reconfigureHeating(zone, force, mode);
	}
}

function sendHeatingCapability()
{
	var heatingCapability = Property.getNode('generalSettings/capabilities/heatingSupported').getValue();
	var coolingCapability = Property.getNode('generalSettings/capabilities/coolingSupported').getValue();
	new Event('HeatingSystemCapability', {
		"HeatingSupported": heatingCapability,
		"CoolingSupported": coolingCapability
	}).raise();
}

//** returns true, if heating capabilities are updated
function updateCapabilities(sendChange) {
	var coolingCapability  = Property.getNode('generalSettings/capabilities/coolingSupported').getValue();
	if (!coolingCapability) {
		var waterHeatingSystemStatus = Property.getNode('/usr/states/heating_water_system/value').getValue();
		if (waterHeatingSystemStatus == StatusWaterHeatingSystem.coldWater) {
			storeParameter('generalSettings/capabilities/coolingSupported', true);
			Property.store();
			// capabilities have changed -> update
			if (sendChange) {
			    sendHeatingCapability();
			}
		}
	}
}

function sendHeatingEnabledEvent() {
	var enabledState = getState('apartment_controller').getValue();
	var enableSwitch = (enabledState != StatusApartmentController.controller_off);

	var waterHeatingSystemStatus = Property.getNode('/usr/states/heating_water_system/value').getValue();
	var bHeatingEnabled = enableSwitch && (waterHeatingSystemStatus == StatusWaterHeatingSystem.hotWater);
	var bCoolingEnabled = enableSwitch && (waterHeatingSystemStatus == StatusWaterHeatingSystem.coldWater);
	lInfo.logln('sendHeatingEnabledEvent: ' + enableSwitch + ' heating: ' + bHeatingEnabled +  " cooling: " + bCoolingEnabled);

	new Event('HeatingEnabled',{'zoneID':0,
		'HeatingEnabled':bHeatingEnabled,
		'CoolingEnabled':bCoolingEnabled
	}).raise();
}

function updateApartmentControllerStatus(sendCapabilitiesChange, triggerAuto) {
	if (Property.getNode('generalSettings/heatingEnabled') == null) {
		lInfo.logln('generalSettings/heatingEnabled is null');
		storeParameter('generalSettings/heatingEnabled',false);
	}
	var apartmentClimateControl  = Property.getNode('generalSettings/heatingEnabled').getValue();

	if (Property.getNode('generalSettings/capabilities/coolingSupported') == null) {
		lInfo.logln('generalSettings/capabilities/coolingSupported is null');
		storeParameter('generalSettings/capabilities/heatingSupported',true);
		storeParameter('generalSettings/capabilities/coolingSupported',false);
	}
	
	updateCapabilities(sendCapabilitiesChange);

	var heatCapabilities = HeatingCapabilities.heatingOnly;
	if (Property.getNode('generalSettings/capabilities/coolingSupported').getValue()) {
		heatCapabilities = HeatingCapabilities.heatingCooling;
	}

	var waterHeatingSystemStatus = Property.getNode('/usr/states/heating_water_system/value').getValue();

	var apartmentControllerOldState = getState('apartment_controller').getValue();

	if (apartmentClimateControl == true) {
		lInfo.logln('updateApartmentControllerStatus climate control on');
		if (heatCapabilities == HeatingCapabilities.heatingOnly) {
			if (waterHeatingSystemStatus == StatusWaterHeatingSystem.hotWater) {
				lInfo.logln('updateApartmentControllerStatus: hot water -> heating');
				getState('apartment_controller').setValue(StatusApartmentController.heating);
			} else {
				lInfo.logln('updateApartmentControllerStatus: no water-> off');
				getState('apartment_controller').setValue(StatusApartmentController.controller_off);
			}
		} else {
			lInfo.logln('updateApartmentControllerStatus heating and cooling');
			if (waterHeatingSystemStatus == StatusWaterHeatingSystem.hotWater) {
				lInfo.logln('updateApartmentControllerStatus: hot water -> heating');
				getState('apartment_controller').setValue(StatusApartmentController.heating);
			} else if (waterHeatingSystemStatus == StatusWaterHeatingSystem.coldWater) {
				lInfo.logln('updateApartmentControllerStatus: cold water-> cooling');
				getState('apartment_controller').setValue(StatusApartmentController.cooling);
			} else {
				lInfo.logln('updateApartmentControllerStatus: no water-> off');
				getState('apartment_controller').setValue(StatusApartmentController.controller_off);
			}
		}
	} else {
		lInfo.logln('updateApartmentControllerStatus climate control -> off');
		getState('apartment_controller').setValue(StatusApartmentController.controller_off);
	}
	var apartmentControllerNewState = getState('apartment_controller').getValue();

	Property.store();

	if (triggerAuto && (apartmentControllerOldState != apartmentControllerNewState)) {
		//trigger automatic controller selection
		if ((apartmentControllerNewState == StatusApartmentController.cooling) ||
		    (apartmentControllerNewState == StatusApartmentController.heating)) {
			lInfo.logln('updateApartmentControllerStatus trigger autoselection');
			triggerAutoselection();
			synchronizeZoneParameters(apartmentControllerNewState,false);
		}
	}

	updateDevices();

	// global switch on/off
	sendApartmentClimateControl();
}

function resetControllerMode(zoneID, statusValue) {
    var pDefinitionID = Property.getNode('controllerConfig/' + zoneID + '/definitionID');
    pDefinitionID.setValue(statusValue);
    Property.store();

    new Event('heating-controller.controller-config', {
        actions : 'resetControllerMode',
        zoneID : '' + zoneID,
        autoselect: 1,
        definitionID: statusValue
    }).raise();
}

if (raisedEvent.name=='running') {
	Property.load();
	if (Property.getNode('controllerDefinitions')==null)
		offlineValues();
	reactOnAbsent();
	ensureQueueTrigger();
	ensureApartmentController();
	insertHolidayTrigger();
	if (Property.getNode('generalSettings/valueProtectionTimeFrame')==null) {
		storeParameter('generalSettings/valueProtectionTimeFrame',15*60);
	}
	if (Property.getNode('generalSettings/valveProtectionWeekday ')==null) {
		storeParameter('generalSettings/valveProtectionWeekday ','TH');
	}
	if (Property.getNode('generalSettings/valveProtectionStartTime')==null) {
		storeParameter('generalSettings/valveProtectionStartTime',15*60*60);
	}
	if (Property.getNode('generalSettings/preheatingTime')==null) {
		storeParameter('generalSettings/preheatingTime',6*60*60);
	}
	
	
	new Event('heating-controller.time-profile',{actions:'queueAllEvents'}).raise();
	new Event('heating-controller.operation-mode',{actions:'sync'}).raise();
	new Event('heating-controller.cloud',{actions:'sync'}).raise();
}

function updateHeatingModeNode(prefix, nodeName, value) {
	if (value != null) {
		lInfo.logln ('updateHeatingModeNode: ' + prefix+ nodeName+ ' Value:' + value);
		storeParameter(prefix + nodeName, "" + value);
	} else {
		var propNode = Property.getNode(prefix + nodeName);
		if (propNode) {
			lInfo.logln ('updateHeatingModeNode, remove node: ' + prefix+ nodeName);
			propNode.getParent().removeChild(propNode);
		}
	}
}